package com.xxp.courtMS.base;

import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.webkit.DownloadListener;
import android.webkit.JsResult;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.RemoteViews;
import android.widget.Toast;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import com.xxp.courtMS.R;

import butterknife.BindView;
import butterknife.ButterKnife;

public abstract class xxBaseWebActivity extends AppCompatActivity {
    public Context mContext;

    @BindView(R.id.comm_web)
    public WebView Comm_Web;

    WebSettings webSet;


    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        mContext = this;
        setContentView(InitView());
        ButterKnife.bind(this);

        Comm_Web = findViewById(R.id.comm_web);
        webSet = Comm_Web.getSettings();
        webSet.setJavaScriptEnabled(true);
        webSet.setAllowFileAccess(false);//设置可以访问文件
        webSet.setUseWideViewPort(false); //将图片调整到适合webview的大小
        webSet.setLoadWithOverviewMode(true); // 缩放至屏幕的大小
        webSet.setLayoutAlgorithm(WebSettings.LayoutAlgorithm.SINGLE_COLUMN); //支持内容重新布局
        webSet.setJavaScriptCanOpenWindowsAutomatically(true); //支持通过JS打开新窗口
        webSet.setCacheMode(WebSettings.LOAD_NO_CACHE); //webview中缓存设置
        webSet.setDatabaseEnabled(false);
        webSet.setAppCacheEnabled(false);
        webSet.setBlockNetworkImage(true);

        Comm_Web.setWebViewClient(new WebViewClient());//本地浏览器显示

        //应用内下载
        Comm_Web.setDownloadListener(new DownloadListener() {
            @Override
            public void onDownloadStart(String url, String userAgent, String contentDisposition, String mimetype, long contentLength) {
                Uri uri=Uri.parse(url);
                Intent intent=new Intent(Intent.ACTION_VIEW,uri);
                startActivity(intent);

            }
        });

        Comm_Web.setWebChromeClient(new WebChromeClient()
        {
            @Override
            public boolean onJsAlert(WebView view, String url, String message, JsResult result) {
                return super.onJsAlert(view, url, message, result);
            }
        });


        InitData();

    }

    public abstract int InitView();

    public abstract void InitData();

    public void ShowLToast(String toast) {
        Toast.makeText(this, toast, Toast.LENGTH_LONG).show();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        Comm_Web.destroy();
    }
}
